# Ex4.py
# Create a file with the following info:
# If a customer recommends movieId1 (premise), they also recommend movieId2 (conclusion), e.g. pair of recommendations.
# Output data structure: lines with pairs and their frequency [movieId1; movieId2; number]
# 10 min runtime for 1000 movies (standard Python 2.7, HP)

import time

datRatings = "ratings.dat"
affinity = "affinity.dat"
moviesInfo = "movies.csv"
numberOfMovies = 50

def loadData(fileName):
    try:    
        fData = open(fileName, 'r')
    except:
        return []
    out = []
    for line in fData:
        line = line[:-1]  # remove \n
        if len(line) == 0:  # empty line
            continue
        li = [i for i in line.split(",")]
        out.append(li)
    fData.close()
    return out

def loadIntData(fileName):
    try:    
        fData = open(fileName, 'r')
    except:
        return []
    out = []
    for line in fData:
        line = line[:-1]  # remove \n
        if len(line) == 0:  # empty line
            continue
        li = [int(i) for i in line.split(",")]
        out.append(li)
    fData.close()
    return out

def getMovieIds():
    movies = loadData(moviesInfo)
    movieIds = []
    for i in range(1,len(movies)):
        movieIds.append(int(movies[i][0]))
    return movieIds

samples = loadIntData(datRatings)
myId = 0
X = [] # list with list for each person with its recommendations
li = []
for sample in samples:
    personId = sample[0]
    if personId != myId:
        X.append(li)
        myId = personId
        li = [sample[1]]
    else:
        li.append(sample[1])

print "Working..."
startTime = time.time()
fOut = open(affinity, "w")
movieIds = getMovieIds()
result = []
for premise in movieIds[0:numberOfMovies]:
    for conclusion in movieIds[premise:numberOfMovies]:
        nb = 0
        for recommendation in X:
            if premise in recommendation and conclusion in recommendation:
               nb += 1
        fOut.write(str(premise) + ";" + str(conclusion) + ";" + str(nb) + "\n")
fOut.close()
print "Done in", time.time() - startTime, "seconds."
