# RegressionPlot.py

from mpl_toolkits.mplot3d import Axes3D
from matplotlib import cm
import matplotlib.pyplot as plt
import numpy as np

fig = plt.figure()
ax = fig.gca(projection='3d')

a = [i for i in range(-1000,1000, 200)]
b = [i for i in range(-10000, 10000, 2000)]
a, b = np.meshgrid(a, b)
E = np.array((a * 1 + b - 2)**2 + (a * 3 + b - 3)**2 + (a * 4 + b - 5)**2
           + (a * 5 + b - 6)**2 + (a * 6 + b - 5)**2 + (a * 8 + b - 7)**2)
ax.plot_surface(a, b, E, rstride=1, cstride=1, cmap=cm.autumn, linewidth=0)

ax.set_xlabel('a')
ax.set_ylabel('b')
ax.set_zlabel('E')
plt.axis((-1000, 1000, -10000, 10000))
plt.show()
